﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Net;
using System.Xml;
using System.Xml.Linq;

namespace TerryLee.SilverlightWithDataServiceDemo
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Uri uri = new Uri("http://localhost:8081/BlogDataService.svc/Posts");
            WebClient client = new WebClient();
            client.OpenReadCompleted += new OpenReadCompletedEventHandler(client_OpenReadCompleted);
            client.OpenReadAsync(uri);
        }

        void client_OpenReadCompleted(object sender,OpenReadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                XmlReader reader = XmlReader.Create(e.Result);

                XDocument postdoc = XDocument.Load(reader);

                XNamespace xmlns = "http://www.w3.org/2005/Atom";
                XNamespace ads = "http://schemas.microsoft.com/ado/2007/08/dataweb";

                var posts = from x in postdoc.Descendants(xmlns + "entry")
                            select new Post
                            {
                                Id = int.Parse(x.Descendants(ads + "Id").First().Value),
                                Title = x.Descendants(ads + "Title").First().Value,
                                Author = x.Descendants(ads + "Author").First().Value
                            };

                Posts.ItemsSource = posts;
            }
        }
    }
}
